function result = DB_oper_demyst(M, rad_idx_dbar, sol, num_pts_in_R, h, G_bar_fft, TR)
%rearranges the solution of the D-Bar algorithm to fit the square, perform
%the D-Bar operation and transform it back:

%M <(size of Q)*2>: size of Q

%rad_idx_dbar <size of Q>*<size of Q>: indices whether grid points are
%inside R or not

%sol <(total number of gridpoints)*2>: solution of the D-Bar equation so
%far

%num_pts_in_R <1>: number of points inside R

%h <1>: spacing of the grid

%G_bar_fft <size of Q>*<size of Q>:  FFT trick operator


sol_square = zeros(M, M);
sol_square(rad_idx_dbar) = sol(1:num_pts_in_R) + 1i*sol((num_pts_in_R+1):end);

% Apply real-linear operator %%eqn. 15.65 from "Linear- and non_liner
% inverse problems"
result = sol_square - h^2*ifft2(G_bar_fft .* fft2( TR.*conj(sol_square) ));

% Construct result as a vector with real and imaginary parts separate
% %%matrl
result = [real(result(rad_idx_dbar)); imag(result(rad_idx_dbar))];